#! /usr/intel/pkgs/bash/4.4/bin/bash

function usage () {
    echo 'Usage: get-row.sh refdb_path sheetname proc rowid var1 var2 ...'
    echo ' => run proc with variables set per: colid=value'
    echo
    echo 'e.g. (using the testrefdb in the refdb repository).'
    echo '> get-row.sh testrefdb Sheet1 echo b 2'
    echo 'b2'
}

refdb_path=$1
sheetname=$2
proc=$3
rowid=$4
shift 4
params_in=($@)

if [[ -z "$rowid" ]];then
    usage
    echo
    echo "ERROR: Missing args."
    exit
fi

infile="$refdb_path/${sheetname}.dat"

trim() {
    local trimmed="$1"

    # Strip leading space.
    trimmed="${trimmed## }"
    # Strip trailing space.
    trimmed="${trimmed%% }"

    echo "$trimmed"
}

function parseIniFile() { #accepts the name of the file to parse as argument ($1)
    #declare syntax below (-gA) only works with bash 4.2 and higher
    unset g_iniProperties
    declare -gA g_iniProperties
    currentSection=""
    while read -r line
    do
        if [[ $line = [*  ]] ; then
               if [[ $line = [* ]] ; then 
                      currentSection=$(echo $line | sed -e 's/\r//g' | tr -d "[]")  
                  fi
		   else
                       # if [[ $line = *' '*  ]] ; then
                       if [[ $line = *' '*  ]] ; then
			   cleanLine=$(echo $line | sed -e 's/\r//g')
#			   key=$(trim $currentSection.$(echo $cleanLine | cut -d'=' -f1))
			   key=$(trim $currentSection.$(echo $cleanLine | cut -d' ' -f1))
                    value=$(trim $(echo $cleanLine | cut -d' ' -f2))
                    g_iniProperties[$key]=$value
                fi
            fi;
        done < $1
}

parseIniFile $infile

for ((i = 0; i < ${#params_in[@]}; i++)); do
    key="${rowid}.${params_in[$i]}"
    params[$i]=${g_iniProperties[$key]}
    # echo "Element $i: '${sentence[i]}'" ; done
done

$proc ${params[@]}
		  
